; PackBits RLE unpacker
; Copyright (c) 2015  Johnathan Roatch
; 
; Copying and distribution of this file, with or without
; modification, are permitted in any medium without royalty
; provided the copyright notice and this notice are preserved
; in all source code copies.
; This file is offered as-is, without any warranty.
;

.export pkb_decode
.exportzp pkb_stream_ptr

PPU_DATA = $2007

.segment "ZEROPAGE"

pkb_stream_ptr:
  pkb_stream_ptr_lo: .res 1
  pkb_stream_ptr_hi: .res 1

.segment "CODE"


;;
; Unpacks a PackBits stream to the PPU
;
; Stream format:
;   0nnnnnnn ...    : N+1 literal bytes.
;   10000000        : End stream.
;   1nnnnnnn xx     : 129-N Run of X.
;
; Input: PPU_ADDR is assumed set, pkb_stream_ptr is start of stream.
; Returns: pkb_stream_ptr (points after the end).
; Trashes: A,X,Y
.proc pkb_decode
  ldx #$00
  ldy pkb_stream_ptr_lo
  stx pkb_stream_ptr_lo
  input_loop:
    lda (pkb_stream_ptr), y
    iny
    bne @__skip
      inc pkb_stream_ptr_hi
    @__skip:
    cpx #$00
    beq read_tag
      bpl do_run
      do_lit:
        sta PPU_DATA
        inx
      jmp input_loop
      do_run:
        inx
        run_loop:
          sta PPU_DATA
          dex
        bne run_loop
      beq input_loop   ; bra

    read_tag:
      eor #$ff
      tax
    bmi input_loop
      inx
    bpl input_loop
  end_stream:
  sty pkb_stream_ptr_lo
rts ; 46 bytes
.endproc

